diff --git a/dlink.c b/dlink.c
index 3463367..cdbfd57 100644
--- a/dlink.c
+++ b/dlink.c
@@ -2,6 +2,15 @@
 /* doubly linked lists */
 /* This is free software. No strings attached. No copyright claimed */
 
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include	<unistd.h>
 #include	<stdlib.h>
 #include	<string.h>
diff --git a/mdadm.h b/mdadm.h
index ebb2ca1..8f3e438 100644
--- a/mdadm.h
+++ b/mdadm.h
@@ -22,8 +22,15 @@
  *    Email: <neilb@suse.de>
  */
 
-#define	_GNU_SOURCE
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include	<unistd.h>
 #ifdef __GLIBC__
 extern __off64_t lseek64 __P ((int __fd, __off64_t __offset, int __whence));
diff --git a/mdmon.c b/mdmon.c
index a16647c..cf3dfa2 100644
--- a/mdmon.c
+++ b/mdmon.c
@@ -42,6 +42,12 @@
 #ifndef _GNU_SOURCE
 #define _GNU_SOURCE
 #endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 
 #include	<unistd.h>
 #include	<stdlib.h>
diff --git a/msg.c b/msg.c
index 0cc7fc5..59de5cc 100644
--- a/msg.c
+++ b/msg.c
@@ -19,6 +19,12 @@
 #ifndef _GNU_SOURCE
 #define _GNU_SOURCE
 #endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include <unistd.h>
 #include <stdio.h>
 #include <string.h>
diff --git a/platform-intel.c b/platform-intel.c
index 95bc492..03811fc 100644
--- a/platform-intel.c
+++ b/platform-intel.c
@@ -16,6 +16,15 @@
  * this program; if not, write to the Free Software Foundation, Inc.,
  * 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
  */
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include "mdadm.h"
 #include "platform-intel.h"
 #include "probe_roms.h"
diff --git a/probe_roms.c b/probe_roms.c
index 94c80c2..2dbfa87 100644
--- a/probe_roms.c
+++ b/probe_roms.c
@@ -19,6 +19,15 @@
  * 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
  */
 
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include "probe_roms.h"
 #include "mdadm.h"
 #include <unistd.h>
diff --git a/swap_super.c b/swap_super.c
index b6db574..92bba9b 100644
--- a/swap_super.c
+++ b/swap_super.c
@@ -1,3 +1,12 @@
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include <unistd.h>
 #include <stdlib.h>
 #include <fcntl.h>
diff --git a/xmalloc.c b/xmalloc.c
index e28d3bd..deadc4e 100644
--- a/xmalloc.c
+++ b/xmalloc.c
@@ -21,6 +21,15 @@
  *    Email: <neilb@suse.de>
  */
 
+#ifndef _GNU_SOURCE
+#define _GNU_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
+#define _FILE_OFFSET_BITS 64
+#endif
+#ifndef _LARGEFILE64_SOURCE
+#define	_LARGEFILE64_SOURCE
+#endif
 #include "xmalloc.h"
 #include "mdadm_status.h"
 
